<template>
    <NuxtLayout :name="'dashboard'">
        <div class="container p-8">
            <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
                @on-search="search" :customEvent="'Cluster'" @on-cluster="cluster" :items="users" />

        </div>
    </NuxtLayout>
</template>

<script lang="ts">
definePageMeta({
    middleware: ["auth"]
})
export default {
    layout: "dashboard",
    data() {
        return {
            toastVisible: false,
            toastTitle: "",
            toastMessage: "",
            tableName: "Users",
            isLoading: false,
            currentPage: 1,
            itemPerPage: 10,
            heads: [
                "No",
                "Name",
                "NIK",
                "Username",
                "Email",
                "Salary",
                "Category",
                "Role",
                "Action",
            ],
            users: [],
        }
    },
    mounted() {
        this.fetchData();
    },
    methods: {
        fetchData(query: string = '') {
            this.isLoading = true;
            const toastStore = useToastStore();
            const config = useRuntimeConfig();
            this.$api
                .get(`/user?search=${query}&page=${this.currentPage}&limit=${this.itemPerPage}`, {
                    headers: {
                        Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                    },
                })
                .then((response) => {
                    let data = response.data;
                    console.log(data);
                    data.map((item: any) => {
                        item.id = item.id;
                        item.name = item.name;
                        item.username = item.username;
                        item.email = item.email;
                        item.role = item.role.name;
                        item.category = item.category ?? 'Belum dikategorikan'
                        item.action = [
                            {
                                icon: "material-symbols:delete-outline-rounded",
                                color: "bg-red-500",
                                disabled: false,
                                callback: 'delete-file',
                            },
                        ];
                        delete item.role.name;
                        delete item.fundings;
                        delete item.payments;
                        delete item.applications;
                        delete item.gender;
                        delete item.address;
                        delete item.birth_place;
                        delete item.birth_date;
                        delete item.nationality;
                        delete item.religion;
                        delete item.job;
                    });
                    this.users = data;
                })
        },
        cluster() {
            this.isLoading = true;
            const toastStore = useToastStore();
            this.$api.put(`/user/cluster`, {}, {
                headers: {
                    Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(`Proses kluster berhasil`, 'success');
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                })
        },
        search(query: string) {
            this.fetchData(query);
        },
        pageUpdate(page: number) {
            this.currentPage = page;
            this.fetchData();
        },
        deleteUser(id: number) {
            // Add your logic for deleting a file
            this.isLoading = true;
            const toastStore = useToastStore();
            this.$api.delete(`/file/${id}`, {
                headers: {
                    Authorization: `Bearer ${localStorage.getItem("access_token")}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(`Dokumen ${title} telah dihapus`, 'success');
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.isLoading = false;
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                })
        }
    },
}

</script>